/*
本程序为Demo程序
重点演示如何使用CPP创建ROS2节点
并每隔一秒输出一次当前时间
*/

#include <rclcpp/rclcpp.hpp>
#include <chrono>

// 时间类
// 初始化时间节点,包含方法:每隔一秒输出一次当前时间
class TimeNode : public rclcpp::Node
{
public:
    // 初始化时间节点
    TimeNode():Node("time_node")
    {
        // 创建一个定时器,每隔一秒打印一次信息
        timer_ = this->create_wall_timer(
            std::chrono::seconds(1),
            [this](){
                // 获取当前时间
                auto now = std::chrono::system_clock::now();
                //输出当前时间
                RCLCPP_INFO(this->get_logger(),"当前时间: %ld",
                    std::chrono::duration_cast<std::chrono::seconds>(now.time_since_epoch()).count()
                );
            }
        );
    }

private:
    // 定义一个定时器对象
    rclcpp::TimerBase::SharedPtr timer_;
};

int main(int argc, char **argv)
{
    // 初始化ROS2:设置接受的参数数量和参数列表
    rclcpp::init(argc, argv);
    // 创建一个时间节点对象
    auto node = std::make_shared<TimeNode>();

    // 进入ROS2事件循环，等待并处理ROS2事件
    rclcpp::spin(node);

    // 关闭ROS2，释放资源
    rclcpp::shutdown();

    return 0;
}